;copper/theme.jl

(let*
    ((font (get-font "-adobe-helvetica-bold-r-normal-*-*-100-*-*-p-*-iso8859-1"))
     (font-colors        (list (get-color "black")
			       (get-color "white")))
     
     (title-images       (list (make-image "title_inact.png")
                            (make-image "title.png")))
     
     (iconify-images     (list (make-image "min_inact.png") (make-image "min.png") 
		               nil (make-image "min_press.png")))
     (maximize-images    (list (make-image "max_inact.png") (make-image "max.png")
 			       nil (make-image "max_press.png")))
     (close-images       (list (make-image "close_inact.png")(make-image "close.png")
                               nil (make-image "close_press.png")))
     (menu-images        (list (make-image "menu_button_inact.png")(make-image "menu_button.png")
                               nil (make-image "menu_button_press.png")))
     
     (border-top         (make-image "top_border.png"))
     (border-bottom      (make-image "bottom_border.png"))
     (border-right       (make-image "right_border.png"))
     (border-left        (make-image "left_border.png"))
     
     (corner-tl-2        (make-image "top_left_corner_2.png"))
     (corner-tr-2        (make-image "top_right_corner_2.png"))
     (corner-tl          (list (make-image "top_left_corner_inact.png")
                            (make-image  "top_left_corner.png")))
     (corner-tr          (list (make-image "top_right_corner_inact.png")
                            (make-image  "top_right_corner.png")))
     (corner-bl          (make-image "lower_left_corner.png"))
     (corner-br          (make-image "lower_right_corner.png"))
     
     (frame
      `(((background   . ,menu-images)
	 (top-edge     . -28)
	 (left-edge    . -13)
	 (class        . menu-button))

	((background  . ,title-images)
	 (foreground  . ,font-colors)
	 (font        . ,font)
	 (text        . ,window-name)
	 (x-justify   . left)
	 (y-justify   . center)
	 (top-edge    . -28)
	 (left-edge   . 29)
	 (right-edge  . 80)
	 (class       . title))

	((background  . ,iconify-images)
	 (top-edge    . -28)
	 (right-edge  . 37) 
	 (class       . iconify-button))

	((background  . ,maximize-images)
	 (top-edge    . -28)
	 (right-edge  . 12)
	 (class       . maximize-button))

	((background  . ,close-images)
	 (top-edge    . -28)
	 (right-edge  . -13)
	 (class       . close-button))

	((background  . ,border-left)
	 (top-edge    . 0)
	 (bottom-edge . 0)
	 (left-edge   . -13) 
	 (class       . left-border))

	((background  . ,border-right)
	 (top-edge    . 0)
	 (bottom-edge . 0)
	 (right-edge  . -13)
	 (class       . right-border))

	((background  . ,border-bottom)
	 (bottom-edge . -13)
	 (right-edge  . 1)  
	 (left-edge   . 1)   
	 (class       . bottom-border))

	((background  . ,corner-tl)
	 (top-edge    . -28)
	 (left-edge   . -13)
	 (class       . top-left-corner))

	((background  . ,corner-tr)
	 (top-edge    . -28)
	 (right-edge  . -13)
	 (class       . top-right-corner))

	((background  . ,corner-bl)
	 (bottom-edge . -13)
	 (left-edge   . -13)  
	 (class       . bottom-left-corner))

	((background  . ,corner-br)
	 (bottom-edge . -13)
	 (right-edge  . -13) 
	 (class       . bottom-right-corner))))

     (shaped-frame
      `(((background . ,title-images)
	 (foreground . ,font-colors)
	 (font       . ,font)
	 (text       . ,window-name)
	 (x-justify  . left)
	 (y-justify  . center)
	 (top-edge   . -28)
	 (left-edge  . 29)
	 (right-edge . 80)
	 (class      . title))

	((background . ,iconify-images)
	 (top-edge   . -28)
	 (right-edge . 37) 
	 (class      . iconify-button))

	((background . ,maximize-images)
	 (top-edge   . -28)
	 (right-edge . 12)
	 (class      . maximize-button))

	((background . ,menu-images)    
	 (top-edge   . -28)
	 (left-edge  . -13)
	 (class      . menu-button))

	((background . ,close-images)
	 (top-edge   . -28)
	 (right-edge . -13)
	 (class      . close-button))

	((background . ,corner-tl)
	 (top-edge   . -28)
	 (left-edge  . -13)
	 (class      . top-left-corner))

	((background . ,corner-tr)
	 (top-edge   . -28)
	 (right-edge . -13)
	 (class      . top-right-corner))))

     (transient-frame
      `(((background . ,border-top)
	 (foreground  . "white")
	 (font        . "-*-lucida-medium-r-normal-*-*-80-*-*-p-*-iso8859-1")
	 (text        . ,window-name)
	 (x-justify   . center)
	 (y-justify   . center)
	 (top-edge   . -13)
	 (left-edge  . 0)
	 (right-edge . 0)
	 (class      . title))

	((background  . ,border-left)
	 (top-edge    . 0)
	 (bottom-edge . 0)
	 (left-edge   . -13) 
	 (class       . left-border))

	((background  . ,border-right)
	 (top-edge    . 0)
	 (bottom-edge . 0)
	 (right-edge  . -13)
	 (class       . right-border))

	((background  . ,border-bottom)
	 (bottom-edge . -13)
	 (right-edge  . 1)  
	 (left-edge   . 1)   
	 (class       . bottom-border))

	((background  . ,corner-tl-2)
	 (top-edge    . -13)
	 (left-edge   . -14)
	 (class       . top-left-corner))

	((background  . ,corner-tr-2)
	  (top-edge   . -13)
	  (right-edge . -14)
	  (class      . top-right-corner))

	 ((background  . ,corner-bl)
	  (bottom-edge . -13)
	  (left-edge   . -13)  
	  (class       . bottom-left-corner))

	 ((background  . ,corner-br)
	  (bottom-edge . -13)
	  (right-edge  . -13) 
	  (class       . bottom-right-corner))))
	
     (shaped-transient-frame
      `(((background   . ,menu-images)
	 (top-edge     . -28)
	 (left-edge    . -13)
	 (class        . menu-button))

	((background   . ,title-images)
	 (foreground   . ,font-colors)
	 (font         . ,font)
	 (text         . ,window-name)
	 (x-justify    . left)
	 (y-justify    . center)
	 (top-edge     . -28)
	 (left-edge    . 29)
	 (right-edge   . 80)
	 (class        . title))				    

	((background   . ,iconify-images)
	 (top-edge     . -28)
	 (right-edge   . 37) 
	 (class        . iconify-button))

	((background   . ,maximize-images)
	 (top-edge     . -28)
	 (right-edge   . 12)
	 (class        . maximize-button))

	((background   . ,close-images)
	 (top-edge     . -28)
	 (right-edge   . -13)
	 (class        . close-button))

	((background   . ,corner-tl)
	 (top-edge     . -28)
	 (left-edge    . -13)
	 (class        . top-left-corner))

	((background   . ,corner-tr)
	 (top-edge     . -28)
	 (right-edge   . -13)
	 (class        . top-right-corner))))
	
     (theme-name 'copper))
  
  (add-frame-style
   theme-name
   (lambda (w type)   
     (cond 
      ((eq type 'shaped) shaped-frame)
      ((eq type 'transient) transient-frame)
      ((eq type 'shaped-transient) shaped-transient-frame)
      ((eq type 'unframed) nil-frame)
      ;; Default frame
      ((<= (car (window-dimensions w)) 115) transient-frame)

      (t frame))))
  (add-hook 'window-resized-hook
	   (lambda (w)
	      (unless (equal resize-outline-mode 'opaque)
		(reframe-one-window w)))))

